[leetcode] Dungeon game

来源:互联网 发布:项目数据库设计 编辑:程序博客网 时间:2024/06/02 00:11
The knight has an initial health point represented by a positive integer. If at any point his health point drops to 0 or below, he dies immediately.

Some of the rooms are guarded by demons, so the knight loses health (negative integers) upon entering these rooms; other rooms are either empty (0's) or contain magic orbs that increase the knight's health (positive integers).

In order to reach the princess as quickly as possible, the knight decides to move only rightward or downward in each step.

Write a function to determine the knight's minimum initial health so that he is able to rescue the princess.

For example, given the dungeon below, the initial health of the knight must be at least 7 if he follows the optimal path RIGHT-> RIGHT -> DOWN -> DOWN.

-2 (K) -3 3
-5          -10    1
10          30    -5 (P)

Notes:
The knight's health has no upper bound.

Any room can contain threats or power-ups, even the first room the knight enters and the bottom-right room where the princess is imprisoned.


Solution 1: Dijkstra 单元最短路

Dijkstra 算法不能求解有负权边的图,而这题的图存在负权边,之所以可以用Dijkstra是因为题目不是求在终点的最大HP,而是路径中的最大HP的最小值。

由于Dijkstra每次选取与起始点最近的节点更新,即尽量使HP大,所以答案不可能比当前HP小。

class Solution {public:    class loc    {        public:        bool operator<( const loc &b ) const        {            return val < b.val;        }        loc( int _x, int _y, int _val ) : x(_x), y(_y), val(_val) { }        int x, y;        int val;    };        int calculateMinimumHP(vector<vector<int>>& dungeon) {        int m = dungeon.size();        if( m == 0 ) return 0;        int n = dungeon[0].size();        int i, j;        for( i = 0; i < m; i++ )        {            vector<int> tmp;            tmp.assign( n, -1e9 );            mark.push_back( tmp );        }        priority_queue<loc> q;        loc start(0, 0, dungeon[0][0]);        q.push( start );                int min = dungeon[0][0];        while( !q.empty() )        {            loc cur = q.top();            q.pop();            if( cur.val < min ) min = cur.val;            if( cur.x == m-1 && cur.y == n-1 )            {                break;            }            if( cur.val < mark[cur.x][cur.y] ) continue;            mark[cur.x][cur.y] = cur.val;            if( cur.x+1 < m )            {                loc next( cur.x+1, cur.y, cur.val+dungeon[cur.x+1][cur.y] );                q.push( next );            }            if( cur.y+1 < n )            {                loc next( cur.x, cur.y+1, cur.val+dungeon[cur.x][cur.y+1] );                q.push( next );            }        }        if( min > 0 ) return 1;        return -min+1;    }        vector<vector<int>> mark;};

Solution 2: DP

若在某点(i,j),已知(i+1,j)和(i,j+1)的答案为a和b,那么可得在点(i,j)的答案为

Max( 1, Min( dp[i+1][j], dp[i][j+1] ) - dungeon[i][j] )

class Solution {public:    int calculateMinimumHP(vector<vector<int>>& dungeon) {        int m = dungeon.size();        if( m == 0 ) return 1;        int n = dungeon[0].size();                int dp[m][n];        int i, j;        dp[m-1][n-1] = max( 1, 1-dungeon[m-1][n-1] );        for( i = m-2; i >= 0; i-- )            dp[i][n-1] = max( 1, dp[i+1][n-1]-dungeon[i][n-1] );        for( j = n-2; j >= 0; j-- )            dp[m-1][j] = max( 1, dp[m-1][j+1]-dungeon[m-1][j] );        for( i = m-2; i >= 0; i-- )        {            for( j = n-2; j >= 0; j-- )            {                dp[i][j] = max( 1, min(dp[i+1][j], dp[i][j+1])-dungeon[i][j] );            }        }                return dp[0][0];    }        inline int max( int a, int b )    {        return (a>b)? a:b;    }        inline int min( int a, int b )    {        return (a<b)? a:b;    }};


0 0
原创粉丝点击